#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_ArmatureCFG.h"
std::auto_ptr<Fish_ArmatureCFG> Fish_ArmatureCFG::msSingleton(nullptr);

int Fish_ArmatureCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_ArmatureCFGData* Fish_ArmatureCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_ArmatureCFGData>& Fish_ArmatureCFG::GetMapData()
{
	return mMapData;
}

void Fish_ArmatureCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_ArmatureCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_ArmatureCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mResType = element->IntAttribute("ResType");
		data.mResName = element->Attribute("ResName");
		data.mResPath = element->Attribute("ResPath");
		data.mMoveAction = element->Attribute("MoveAction");
		data.mDieAction = element->Attribute("DieAction");
		data.mColor = element->IntAttribute("Color");
		data.mScale = element->FloatAttribute("Scale");
		data.mEnableFlipped = element->BoolAttribute("EnableFlipped");
		{
			const char* Collider = element->Attribute("Collider");
			std::vector<std::string> vecCollider;
			boost::split(vecCollider, Collider, boost::is_any_of(","));
			float temp;
			for (unsigned int i = 0; i < vecCollider.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToFloat(vecCollider[i].c_str(), &temp))
				{
					data.mCollider.push_back(temp);
				}
			}
		}
		{
			const char* AttachArmatures = element->Attribute("AttachArmatures");
			std::vector<std::string> vecAttachArmatures;
			boost::split(vecAttachArmatures, AttachArmatures, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAttachArmatures.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAttachArmatures[i].c_str(), &temp))
				{
					data.mAttachArmatures.push_back(temp);
				}
			}
		}
		data.mFixFlag = element->Attribute("FixFlag");
		{
			const char* Circles = element->Attribute("Circles");
			std::vector<std::string> vecCircles;
			boost::split(vecCircles, Circles, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecCircles.size(); i++)
			{
				data.mCircles.push_back(vecCircles[i]);
			}
		}
		{
			const char* AttachParticles = element->Attribute("AttachParticles");
			std::vector<std::string> vecAttachParticles;
			boost::split(vecAttachParticles, AttachParticles, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecAttachParticles.size(); i++)
			{
				data.mAttachParticles.push_back(vecAttachParticles[i]);
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_ArmatureCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ArmatureCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_ArmatureCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_ArmatureCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_ArmatureCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "ResType", data.mResType);
		LuaCfgHelper::readString(L, "ResName", data.mResName);
		LuaCfgHelper::readString(L, "ResPath", data.mResPath);
		LuaCfgHelper::readString(L, "MoveAction", data.mMoveAction);
		LuaCfgHelper::readString(L, "DieAction", data.mDieAction);
		LuaCfgHelper::readInt(L, "Color", data.mColor);
		LuaCfgHelper::readFloat(L, "Scale", data.mScale);
		LuaCfgHelper::readBool(L, "EnableFlipped", data.mEnableFlipped);
		LuaCfgHelper::readVectorFloat(L, "Collider", data.mCollider);
		LuaCfgHelper::readVectorInt(L, "AttachArmatures", data.mAttachArmatures);
		LuaCfgHelper::readString(L, "FixFlag", data.mFixFlag);
		LuaCfgHelper::readVectorString(L, "Circles", data.mCircles);
		LuaCfgHelper::readVectorString(L, "AttachParticles", data.mAttachParticles);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_ArmatureCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ArmatureCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_ArmatureCFG* Fish_ArmatureCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_ArmatureCFG());
	}
	return msSingleton.get();
}

void Fish_ArmatureCFG::Release()
{
	msSingleton.reset(nullptr);
}
